*! version 0.3.7 2014-08-10 | scott long | diag
*  version 0.3.6 2014-08-09 | scott long | add, get, transpose
*  version 0.3.5 2014-08-09 | scott long | label with spaces
*  version 0.3.4 2014-08-08 | scott long | labels with keep drop, format
*  version 0.3.3 2014-08-08 | scott long | label tweak
*  version 0.3.2 2014-08-08 | scott long | abs
*  version 0.3.1 2014-08-03 | scott long | labels
*  version 0.3.0 2014-08-02 | scott long | tempname
*  version 0.2.1 2014-08-01 | long | scalar

//  matmath: math operations on matrices

capture program drop _matmath

program _matmath, sclass

    version 11.2
    syntax, matout(string) matleft(string) ///
        isunary(string) isbinary(string) isbook(string) ///
        isget(string) isscalar(string) ///
        [ matright(string) operator(string) ] ///
        [ list cols(string) rows(string) format(string) ///
        addvalue(string) name(string) transpose ]

    tempname scalarright matrows matcols origreturns
    _return hold `origreturns'
    local isadd = 0 // is add used?

if "$debug"=="1" di "matout `matout'"

    mata: `matleft' = st_matrix(st_local("matleft"))
    local matleftrownms : rowfullnames `matleft', quoted
    local matleftcolnms : colfullnames `matleft', quoted
    local matleftrowsN = rowsof(`matleft')
    local matleftcolsN = colsof(`matleft')

//  binary operations

    if `isbinary' {

        if `isscalar' {
            matrix `scalarright' = J(1,1,`matright')
            mata: `matright' = st_matrix("`scalarright'")
        }
        else mata: `matright' = st_matrix(st_local("matright"))
        local useleftrownms = 0
        local useleftcolnms = 0

        * math operations
        if "`operator'"=="-" {
            mata: `matout' = `matleft' :- `matright'
            mata: st_matrix(st_local("matout"),`matout')
            local useleftrownms = 1
            local useleftcolnms = 1
        }
        else if "`operator'"=="+" {
            mata: `matout' = `matleft' :+ `matright'
            mata: st_matrix(st_local("matout"),`matout')
            local useleftrownms = 1
            local useleftcolnms = 1
        }
        else if "`operator'"=="*" {
            mata: `matout' = `matleft' :* `matright'
            mata: st_matrix(st_local("matout"),`matout')
            local useleftrownms = 1
            local useleftcolnms = 1
        }
        else if "`operator'"=="/" {
            mata: `matout' = `matleft' :/ `matright'
            mata: st_matrix(st_local("matout"),`matout')
            local useleftrownms = 1
            local useleftcolnms = 1
        }
        else if "`operator'"=="^" {
            mata: `matout' = `matleft' :^ `matright'
            mata: st_matrix(st_local("matout"),`matout')
            local useleftrownms = 1
            local useleftcolnms = 1
        }
        * what percent is first matrix of second matrix
        else if "`operator'"=="%of" {
            mata: `matout' = 100*(`matleft' :/ `matright')
            mata: st_matrix(st_local("matout"),`matout')
            local useleftrownms = 1
            local useleftcolnms = 1
        }
        * percent change from first to second matrix
        else if "`operator'"=="%dif" {
            mata: `matout' = 100*((`matright' :- `matleft' ):/ `matleft')
            mata: st_matrix(st_local("matout"),`matout')
            local useleftrownms = 1
            local useleftcolnms = 1
        }
        * stacking operations
        else if `isscalar' ///
            & ("`operator'"=="," | "`operator'"==",," | ///
               "`operator'"=="\" | "`operator'"=="\\") {
            di as err "operator `operator' is not allowed with scalars"
            _return restore `origreturns'
            exit
        }
        else if "`operator'"=="," {
            matrix `matout' = `matleft' , `matright'
            local useleftrownms = 1
        }
        else if "`operator'"=="\" {
            matrix `matout' = `matleft' \ `matright'
            local useleftcolnms = 1
        }
        else if "`operator'"==",," {
            mat_capp `matout' : `matleft' `matright', miss(.)
        }
        else if "`operator'"=="\\" {
            mat_rapp `matout' : `matleft' `matright', miss(.)
        }

        * attach labels
        if `useleftrownms' matrix rownames `matout' = `matleftrownms'
        if `useleftcolnms' matrix colnames `matout' = `matleftcolnms'

    } // binary

    else if `isunary' {

        local useleftrownms = 0
        local useleftcolnms = 0
        if "`operator'"=="sqrt" {
            mata: `matout' = sqrt(`matleft')
            mata: st_matrix(st_local("matout"),`matout')
            local useleftrownms = 1
            local useleftcolnms = 1
        }
        else if "`operator'"=="abs" {
            mata: `matout' = abs(`matleft')
            mata: st_matrix(st_local("matout"),`matout')
            local useleftrownms = 1
            local useleftcolnms = 1
        }
        else if "`operator'"=="sq" {
            mata: `matout' = `matleft' :* `matleft'
            mata: st_matrix(st_local("matout"),`matout')
            local useleftrownms = 1
            local useleftcolnms = 1
        }
        else if "`operator'"=="log" {
            mata: `matout' = log(`matleft')
            mata: st_matrix(st_local("matout"),`matout')
            local useleftrownms = 1
            local useleftcolnms = 1
        }
        else if "`operator'"=="log10" {
            mata: `matout' = log10(`matleft')
            mata: st_matrix(st_local("matout"),`matout')
            local useleftrownms = 1
            local useleftcolnms = 1
        }
        else if "`operator'"=="exp" {
            mata: `matout' = exp(`matleft')
            mata: st_matrix(st_local("matout"),`matout')
            local useleftrownms = 1
            local useleftcolnms = 1
        }
        else if "`operator'"=="inv" {
            mata: `matout' = 1 :/ `matleft'
            mata: st_matrix(st_local("matout"),`matout')
            local useleftrownms = 1
            local useleftcolnms = 1
        }
        else if ("`operator'"=="logit") ///
            mata: `matout' = log( `matleft' :/ (1 :- `matleft') )
            mata: st_matrix(st_local("matout"),`matout')
            local useleftrownms = 1
            local useleftcolnms = 1
        else if ("`operator'"=="odds") ///
            mata: `matout' = ( `matleft' :/ (1 :- `matleft') )
            mata: st_matrix(st_local("matout"),`matout')
            local useleftrownms = 1
            local useleftcolnms = 1

        if `useleftrownms' matrix rownames `matout' = `matleftrownms'
        if `useleftcolnms' matrix colnames `matout' = `matleftcolnms'

    } // unary

    else if `isbook' {

        * put `matleft' into mata as `matout'
        mata: `matout' = st_matrix(st_local("matleft"))

        if "`operator'"=="keep" {

            * row indices
            if ("`rows'"=="") matrix `matrows' = J(1,1,.)
            else {
                foreach r in `rows' {
                    if `r'>`matleftrowsN' | `r'<1 {
                        di as error ///
                            "row `r' in keep() is invalid"
                        local iserror = 1
                    }
                }
                local tmp = subinstr("`rows'"," ","\",.)
                matrix `matrows' = (`tmp')
            }
            mata: `matrows' = st_matrix("`matrows'")

            * column indices
            if ("`cols'"=="") matrix `matcols' = J(1,1,.)
            else {
                foreach c in `cols' {
                    if `c'>`matleftcolsN' | `c'<1 {
                        di as error ///
                            "column `c' in keep() is invalid"
                        local iserror = 1
                    }
                }
                local tmp = subinstr("`cols'"," ","\",.)
                matrix `matcols' = (`tmp')
            }
            mata: `matcols' = st_matrix("`matcols'")

            if "`iserror'"=="1" {
                _return restore `origreturns'
                exit
            }

            mata: `matout' = `matout'[`matrows',`matcols']
            mata: st_matrix(st_local("matout"),`matout')

        } // keep

        else if "`operator'"=="drop" {

            * matrix with rows to keep
            local tmpindices ""
            forvalues row = 1/`matleftrowsN' {
                local ipos : list posof "`row'" in rows
                if (`ipos'==0) local tmpindices "`tmpindices' \ `row'"
            }
            local tmpindices = subinstr("`tmpindices'"," \ ","",1)
            matrix `matrows' = (`tmpindices')
            * remove \ between indices
            local rows = subinstr("`tmpindices'","\"," ",.) // used later
            mata: `matrows' = st_matrix("`matrows'")

            * with columns
            local tmpindices ""
            forvalues col = 1/`matleftcolsN' {
                local ipos : list posof "`col'" in cols
                if (`ipos'==0) local tmpindices "`tmpindices' , `col'"
            }
            local tmpindices = subinstr("`tmpindices'"," , ","",1)
            matrix `matcols' = (`tmpindices')
            * remove , between indices
            local cols = subinstr("`tmpindices'",","," ",.)
            mata: `matcols' = st_matrix("`matcols'")

            mata: `matout' = `matout'[`matrows',`matcols']
            mata: st_matrix(st_local("matout"),`matout')

        } // drop

        else if "`operator'"=="add" {

            if "`rows'"!="" { // add row vector
                local isadd = 1
                tempname newvec
                matrix `newvec' = J(1,`matleftcolsN',`addvalue')
                if ("`name'"!="") matrix rowname `newvec' = `name'

if "$debug"=="1" matlist `newvec', title(newvec row)
if "$debug"=="1" matlist `matleft', title(matleft row)

                * create new matrix
                if `rows'== 0 {
                    matrix `matout' = `newvec' \ `matleft'
                }
                else if `rows'==`matleftrowsN' {
                    matrix `matout' = `matleft' \ `newvec'
                }
                else {
                    tempname mat1 mat2
                    local st1 = `rows' + 1
                    matrix `mat1' = `matleft'[1..`rows',1...]
                    matrix `mat2' = `matleft'[`st1'...,1...]
                    matrix `matout' = `mat1' \ `newvec' \ `mat2'
                }

if "$debug"=="1" matlist `matout', title(matout row)

            } // rows add

            if "`cols'"!="" { // add col vector
                local isadd = 1
                tempname newvec matadd

                if "`rows'"!="" {
                    matrix `matadd' = `matout' // in case rows were added
                    local matleftrowsN = rowsof(`matadd')
                }
                else matrix `matadd' = `matleft'
                matrix `newvec' = J(`matleftrowsN',1,`addvalue')
                if ("`name'"!="") matrix colname `newvec' = `name'

if "$debug"=="1" matlist `newvec', title(newvec cols)
if "$debug"=="1" matlist `matadd', title(matadd for col)

                * create new matrix
                if `cols'== 0 {
                    matrix `matout' = `newvec' , `matadd'
                }
                else if `cols'==`matleftcolsN' {
                    matrix `matout' = `matadd' , `newvec'
                }
                else {
                    tempname mat1 mat2
                    local st1 = `cols' + 1
                    matrix `mat1' = `matadd'[1...,1..`cols']
                    matrix `mat2' = `matadd'[1...,`st1'...]
                    matrix `matout' = `mat1' , `newvec' , `mat2'
                }
            } // cols add

        } // add

        * reattach labels
        if `isadd'==0 { // not used with add
            if "`rows'"!="" { // selected rows
                foreach row in `rows' {
                    local rnm : word `row' of `matleftrownms'
                    * `"` '"' needed since names have ""s in them
                    local newrownms `" `newrownms' `"`rnm'"' "'
                }
                matrix rownames `matout' = `newrownms'
            } // if rows selected
            else matrix rownames `matout' = `matleftrownms'

            if "`cols'"!="" { // selected columns
                foreach col in `cols' {
                    local cnm : word `col' of `matleftcolnms'
                    local newcolnms `" `newcolnms' `"`cnm'"' "'
                }
                matrix colnames `matout' = `newcolnms'
            } //if cols selected
            else matrix colnames `matout' = `matleftcolnms'
        }

    } // book and add

    else if `isget' { // get

        if "`name'"!="" & "`operator'"=="diag" {
            matrix rowname `matleft' = `name'
        }
        matrix `matout' = `matleft'
    }

    if ("`transpose'"=="transpose") matrix `matout' = `matout''
    if ("`list'"=="list") ///
        matlist `matout', title(matrix `matout') format(`format')

end
exit

    if "`eq'" == "" {
        matrix list `matout'
        exit
    }

    if "`matleft'"=="" {
        display as error ///
        "matmath A = B <op> C: matrix B is not specified"
        exit
    }

    if "`eq'"!="=" {
        display as error ///
        "matmath A = B <op> C: equal sign is missing"
        exit
    }

    if "`matright'"=="" {
        display as error ///
        "matmath A = B <op> C: matrix C is not specified"
        exit
    }

    if "`op'"=="" {
        display as error ///
        "matmath A = B <op> C: <op> is not specified"
        exit
    }
