{smcl}
{* 2014-08-16}{...}
{title:Title}
{p2colset 5 16 23 2}{...}

{p2col:{cmd:matmath} {hline 2}}Matrix operations made simple | 2014-08-01{p_end}
{p2colreset}{...}


{title:General syntax}

{p 2 18 2}
{ul:Operations on two matrices}

{p 6 6 2}
{cmd:matmath } {it:newmatrix} = {it:leftmatrix} {it:operator} {it:rightmatrix}

{p 2 18 2}
{ul:Transformations of elements of a matrix}

{p 6 6 2}
{cmd:matmath } {it:newmatrix} = {it:operator}{bf:(}{it:sourcematrix}{bf:)}

{p 2 18 2}
{ul:Bookkeeping operations}

{p 6 9 2}
{cmd:matmath } {it:newmatrix} = {it:task}{bf:(}{it:sourcematrix}{bf:)},
{opt rows(numlist)} | {opt col:umns(numlist)} [ {opt v:alue(number)} {opt name(string)} ]

{p 2 18 2}
{ul:Retrieving a matrix}

{p 6 9 2}
{cmd:matmath } {it:newmatrix} = {it:task}{bf:(}{it:sourcematrix}{bf:)}

{p 2 18 2}
{ul:General options}

{p2colset 7 25 26 12}{...}
{synopt:{opt list}}
List matrix after changes.
{p_end}

{synopt:{opt transpose}}
Transpose the matrix after the operation is completed.
{p_end}

{synopt:{opt format(fmt)}}
Use {it:fmt} to format listing; default is %9.3f.
{p_end}

{synopt:{opt w:idth(integer)}}
Width used in format; default is 9.
{p_end}

{synopt:{opt d:ecimals(integer)}}
Decimals used in format; default is 3.
{p_end}


{p 2 18 2}
{ul:Matrices and scalars used}

{p 6 6 2}
{it:newmatrix} is the resulting matrix, which can be an existing matrix. An existing matrix will be over-written. The row and column names in {it:newmatrix} correspond to those in {it:leftmatrix}.

{p 6 6 2}
{it:leftmatrix} is the first matrix in binary operations like addition.

{p 6 6 2}
{it:rightmatrix} is the second matrix in binary operations and must be the same dimension as {it:leftmatrix}. Alterntively, it can be a scalar.

{p 6 6 2}
{it:sourcematrix} is the matrix that is modified.

{marker overview}
{title:Overview}

{pstd}
{cmd:matmath} makes basic matrix operations simpler than {cmd:matrix} or {cmd:mata}. Binary operations are elment by element operations.
{p_end}


{title:Expanded syntax}


{dlgtab:Operations on two matrices}

{p 6 10 2}
{cmd:matmath } {it:newmatrix} = {it:leftmatrix} {it:operator} {it:rightmatrix}

{p2colset 10 22 22 8}{...}
{p2col :Operator}What it does{p_end}
{p2line}
{p2col :{bf:+}}Addition of left and right{p_end}
{p2col :{bf:-}}Subtraction left from right{p_end}
{p2col :{bf:*}}Multiplication left times right{p_end}
{p2col :{bf:/}}Division left by right{p_end}
{p2col :{bf:^}}Exponentiation of left to right power{p_end}
{p2col :{bf:%of}}Left as percent of right{p_end}
{p2col :{bf:%dif}}Change from left to right as percent of left{p_end}
{p2col :{bf:,}}Column concantenate left with right{p_end}
{p2col :{bf:,,}}Column concantenate left with right using {cmd:mat_capp}{p_end}
{p2col :{bf:\}}Row concantenate left with right (i.e., stack){p_end}
{p2col :{bf:\\}}Row concantenate left with right using {cmd:mat_rapp}{p_end}
{p2line}
{p2colset 7 21 22 0}
{pstd}
{p_end}

{dlgtab:Transformations on a matrix}

{p 6 10 2}
{cmd:matmath } {it:newmatrix} = {it:operator}({it:sourcematrix})

{p2colset 10 22 22 8}{...}
{p2col :Operator}What it does{p_end}
{p2line}
{p2col :{bf:abs}}Absolute value{p_end}
{p2col :{bf:sqrt}}Square root{p_end}
{p2col :{bf:sq}}Square{p_end}
{p2col :{bf:log}}Natural log{p_end}
{p2col :{bf:exp}}exponential{p_end}
{p2col :{bf:inv}}Inverse{p_end}
{p2col :{bf:log10}}Log base 10{p_end}
{p2col :{bf:odds}}Odds transformation (x/(1-x)){p_end}
{p2col :{bf:logit}}Logit transformation log(x/(1-x)){p_end}
{p2line}
{p2colset 7 21 22 0}
{pstd}
{p_end}

{dlgtab:Changing the size and ordering of a matrix}

{p 6 10 2}
{cmd:matmath } {it:newmatrix} = {it:task}{bf:(}{it:sourcematrix}{bf:)}, options

{p2colset 10 22 22 6}{...}
{p2col :Task}What it does{p_end}
{p2line}
{p2col :{bf:keep}}Keep rows and columns in {bf:rows()} and {bf:columns()}.{p_end}
{p2col :{bf:drop}}Drop rows and columns in {bf:rows()} and {bf:columns()}. The original ordering is maintained.{p_end}
{p2col :{bf:add}}Add a row and/or a column filled with the value specified by {bf:value()}.{p_end}
{p2col :{bf:diag}}Make {it:newmatrix} a vector from the diagonal of {it:sourcematrix}.{p_end}
{p2line}
{p2colset 7 21 22 0}
{pstd}
{p_end}
{p 6 10 2}
{ul:Options for keep and drop}
{p2colset 9 26 27 0}

{synopt:{opt r:ows(numlist)}}
Select rows from {it:leftmatrix}. {bf:l} indicates the last row.
{p_end}

{synopt:{opt c:olumns(numlist)}}
Select columns from {it:leftmatrix}. {bf:l} indicates the last column.
{p_end}

{p 8 8 2}
With {cmd:keep}, the specified order is retained in {it:newmatrix} and the same rows can be repeated.

{p 6 10 2}
{ul:Options for add}
{p2colset 9 26 27 0}

{synopt:{opt r:ow(integer)}}
A row is added after the specified row. {bf:0} indicates a new row at the top; {bf:l} indicates a new row at the bottom.
{p_end}

{synopt:{opt c:olumn(integer)}}
A column is added after the specified column. {bf:0} indicates a new column at the left; {bf:l} indicates the last column.
{p_end}

{synopt:{opt v:alue(real or missing)}}
The new row or column contains this value; by default . is used.
{p_end}

{synopt:{opt name(string)}}
Matrix rowname or colname for the added row or colunns.
{p_end}

{dlgtab:Retrieving matrices}

{p 6 10 2}
{cmd:matmath } {it:newmatrix} = {it:task}{bf:(}{it:sourcematrix}{bf:)}, options

{p2colset 10 22 22 4}{...}
{p2col :Task}What it does{p_end}
{p2line}
{p2col :{bf:get}}Make {it:newmatrix} equal to {it:sourcematrix}.{p_end}
{p2col :{bf:e}}Make {it:newmatrix} equal to {cmd:e(}{it:sourcematrix}{bf:)}, such as {bf:matmath a = e(b)}.{p_end}
{p2col :{bf:r}}Make {it:newmatrix} equal to {cmd:r(}({it:sourcematrix}{bf:)}.{p_end}
{p2line}
{p2colset 7 21 22 0}
{pstd}

{p 6 10 2}
{cmd:matmath } {it:newmatrix} = {it:task}, options

{p2colset 10 22 22 4}{...}
{p2col :Task}What it does{p_end}
{p2line}
{p2col :{bf:table}}Make {it:newmatrix} equal to {cmd:r(table)}.{p_end}
{p2col :{bf:eb}}Make {it:newmatrix} equal to {cmd:e(b)}.{p_end}
{p2col :{bf:rb}}Make {it:newmatrix} equal to {cmd:r(b)}.{p_end}
{p2col :{bf:ev}}Make {it:newmatrix} equal to {cmd:e(V)}.{p_end}
{p2col :{bf:rv}}Make {it:newmatrix} equal to {cmd:r(V)}.{p_end}
{p2line}
{p2colset 7 21 22 0}
{pstd}
{p_end}
{p 6 10 2}

{title:Author}

{p 2 5 10}
Scott Long

{p 2 8 0}
{browse "http://www.indiana.edu/~jslsoc/spost.htm":The SPost website.}
{browse "http://www.indiana.edu/~jslsoc/web_workflow/wf_home.htm":The Workflow website.}
{p_end}
